'From Squeak3.2 of 26 February 2002 [latest update: #4956] on 23 August 2002 at 8:26:28 pm'!

!Object methodsFor: 'private' stamp: 'svp 8/12/2002 13:57'!
similarInstance
	"Answer an instance of the the same class for reconstructing the receiver.  
	For example, a write stream will grow its underlying collection whenever an
	attempt is made to write past the end of the current collection."

	^self class new! !

!Object methodsFor: 'private' stamp: 'svp 8/12/2002 13:57'!
similarInstance: size
	"Answer an instance of the the same class for reconstructing the receiver.  
	For example, a write stream will grow its underlying collection whenever an
	attempt is made to write past the end of the current collection."

	^self class new: size! !

!Object methodsFor: 'private' stamp: 'svp 8/12/2002 13:53'!
similarSpeciesInstance
	"Answer *an instance* of the preferred class for reconstructing the receiver.  
	For example, collections create new collections whenever enumeration messages such as 
	collect: or select: are invoked.  The new kind of collection is determined by 
	the species of the original collection.  Species and class are not always the 
	same.  For example, the species of Interval is Array."

	^self species new! !

!Object methodsFor: 'private' stamp: 'svp 8/12/2002 13:54'!
similarSpeciesInstance: size
	"Answer *an instance* of the preferred class for reconstructing the receiver.  
	For example, collections create new collections whenever enumeration messages such as 
	collect: or select: are invoked.  The new kind of collection is determined by 
	the species of the original collection.  Species and class are not always the 
	same.  For example, the species of Interval is Array."

	^self species new: size! !

!Object methodsFor: 'private' stamp: 'svp 8/12/2002 13:58'!
species
	"Answer the preferred class for reconstructing the receiver.  For example, 
	collections create new collections whenever enumeration messages such as 
	collect: or select: are invoked.  The new kind of collection is determined by 
	the species of the original collection.  Species and class are not always the 
	same.  For example, the species of Interval is Array.  **NOTE: Always consider
	using #similarSpeciesInstance or #similarSpeciesInstance: instead of this method 
	as they offer the receiver a chance to do additional initialization of the new 
	instance based on state of the receiver."

	^self class! !


!B3DIndexedQuad methodsFor: 'private' stamp: 'svp 8/12/2002 10:17'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	^self primitiveFailed! !


!B3DIndexedTriangle methodsFor: 'private' stamp: 'svp 8/12/2002 10:18'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	^self primitiveFailed! !


!B3DPrimitiveRasterizerData methodsFor: 'private' stamp: 'svp 8/12/2002 10:07'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart
	"Private. Used for growing rasterizer data only."
	<primitive: 105>
	^self primitiveFailed! !

!B3DPrimitiveRasterizerData methodsFor: 'private' stamp: 'svp 8/12/2002 10:07'!
startingAt: index replace: target from: start to: stop
	"This destructively replaces elements from start to stop in the target 
	starting at index in the receiver. Answer the receiver. No range checks are 
	performed."

	target basicReplaceFrom: start to: stop with: self startingAt: index! !


!Integer methodsFor: 'system primitives' stamp: 'svp 8/12/2002 10:04'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart
	| j |  "Catches failure if LgInt replace primitive fails"
	j _ repStart.
	start to: stop do:
		[:i |
		self digitAt: i put: (replacement digitAt: j).
		j _ j+1]! !

!Integer methodsFor: 'system primitives' stamp: 'svp 8/12/2002 10:04'!
startingAt: index replace: target from: start to: stop
	"This destructively replaces elements from start to stop in the target 
	starting at index in the receiver. Answer the receiver. No range checks are 
	performed."

	target basicReplaceFrom: start to: stop with: self startingAt: index! !


!LargePositiveInteger methodsFor: 'system primitives' stamp: 'svp 8/12/2002 10:05'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	^ super basicReplaceFrom: start to: stop with: replacement startingAt: repStart! !


!SequenceableCollection methodsFor: 'replacement' stamp: 'svp 8/12/2002 10:36'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"This is the basic version of #replaceFrom:to:with:startingAt:. It assumes that
	the replacement collection's elements can be accessed directly. Clients should
	not send this method directly (use #replaceFrom:to:with:startingAt: instead). Subclasses
	may want to override this method with an optimized implementation.  When
	overridding this method, you may delegate by sending 
	#basicReplaceFrom:to:with:startingAt: to another object (where the replacement 
	collection is the same collections passed into this method) because at this point, the
	replacement collection has already had the opportunity to hook in by overriding
	#startingAt:replace:from:to: (basically this means that it's ok and even preferred
	to send #basicReplaceFrom:to:with:startingAt: from implementations of this method).

	This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	| index repOff |
	repOff _ repStart - start.
	index _ start - 1.
	[(index _ index + 1) <= stop]
		whileTrue: [self at: index put: (replacement at: repOff + index)]! !

!SequenceableCollection methodsFor: 'replacement' stamp: 'svp 8/12/2002 09:54'!
startingAt: index replace: target from: start to: stop
	"This destructively replaces elements from start to stop in the target 
	starting at index in the receiver. Answer the receiver. No range checks are 
	performed."

	target basicReplaceFrom: start to: stop with: self startingAt: index! !


!Array methodsFor: 'private' stamp: 'svp 8/12/2002 10:17'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super basicReplaceFrom: start to: stop with: replacement startingAt: repStart! !


!Bitmap methodsFor: 'accessing' stamp: 'svp 8/12/2002 10:18'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super basicReplaceFrom: start to: stop with: replacement startingAt: repStart! !


!ByteArray methodsFor: 'private' stamp: 'svp 8/12/2002 10:19'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super basicReplaceFrom: start to: stop with: replacement startingAt: repStart! !


!FloatArray methodsFor: 'private' stamp: 'svp 8/12/2002 10:19'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super basicReplaceFrom: start to: stop with: replacement startingAt: repStart! !


!B3DInplaceArray methodsFor: 'private' stamp: 'svp 8/12/2002 10:18'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart
	| max |
	max _ (replacement size - repStart) min: stop-start.
	start to: start+max do:[:i|
		self at: i put: (replacement at: i - start + repStart).
	].! !


!Set methodsFor: 'private' stamp: 'svp 8/23/2002 09:24'!
compare: element with: object

	^element = object! !

!Set methodsFor: 'private' stamp: 'svp 8/23/2002 09:48'!
findElementOrNil: anObject hash: hash
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index _ self scanFor: anObject hash: hash.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!Set methodsFor: 'private' stamp: 'svp 8/23/2002 08:40'!
getHashFor: object

	^object hash! !

!Set methodsFor: 'private' stamp: 'svp 8/23/2002 09:47'!
scanFor: anObject hash: hash
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	^self 
		scanFor: anObject 
		startingAt: (hash \\ array size) + 1
! !

!Set methodsFor: 'private' stamp: 'svp 8/23/2002 10:09'!
scanFor: anObject startingAt: start
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element |

	"Search from (hash mod size) to the end."
	start to: array size do:
		[:index | ((element _ array at: index) == nil or: 
			[self compare: element with: anObject])
				ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element _ array at: index) == nil or: 
			[self compare: element with: anObject])
				ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !


!Dictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:34'!
compare: element with: object

	^element key = object! !


!IdentityDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:18'!
compare: element with: object

	^element key == object! !

!IdentityDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 15:58'!
getHashFor: object

	^array size > 4096
		ifTrue: [object identityHash hashMultiply]
		ifFalse: [object identityHash]! !


!IdentitySet methodsFor: 'private' stamp: 'svp 8/23/2002 09:19'!
compare: element with: object

	^element == object! !

!IdentitySet methodsFor: 'private' stamp: 'svp 8/23/2002 09:14'!
getHashFor: object

	^array size > 4096
		ifTrue: [object identityHash hashMultiply]
		ifFalse: [object identityHash]! !


!LiteralDictionary methodsFor: 'private' stamp: 'yo 1/27/2001 05:06'!
arrayEquality: x and: y

	x size = y size ifFalse: [^ false].
	x with: y do: [:e1 :e2 | 
		(self literalEquality: e1 and: e2) ifFalse: [^ false]
	].
	^true.
! !

!LiteralDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:21'!
compare: element with: object

	^ self literalEquality: element key and: object! !

!LiteralDictionary methodsFor: 'private' stamp: 'yo 1/27/2001 05:13'!
literalEquality: x and: y

	^ (x class = Array and: [y class = Array]) ifTrue: [
		self arrayEquality: x and: y.
	] ifFalse: [
		(x class == y class) and: [x = y]
	].
! !


!MethodDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:03'!
compare: one with: another

	^one == another! !

!MethodDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:03'!
getHashFor: anObject

	^anObject identityHash! !

!MethodDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 17:32'!
scanFor: anObject startingAt: start
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element |

	"Search from (hash mod size) to the end."
	start to: array size do:
		[:index | ((element _ self basicAt: index) == nil or: 
			[element == anObject])
				ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element _ self basicAt: index) == nil or: 
			[element == anObject])
				ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !


!PluggableDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:23'!
compare: element with: object

	^equalBlock 
		ifNil: [element key = object]
		ifNotNil: [equalBlock value: element key value: object]! !

!PluggableDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:00'!
getHashFor: object

	^hashBlock 
		ifNil: [object hash]
		ifNotNil: [hashBlock value: object]! !


!PluggableSet methodsFor: 'private' stamp: 'svp 8/23/2002 09:23'!
compare: element with: object

	^equalBlock 
		ifNil: [element = object]
		ifNotNil: [equalBlock value: element value: object]! !

!PluggableSet methodsFor: 'private' stamp: 'svp 8/23/2002 08:57'!
getHashFor: object

	^hashBlock 
		ifNil: [object hash]
		ifNotNil: [hashBlock value: object]! !


!String methodsFor: 'private' stamp: 'svp 8/12/2002 10:20'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super basicReplaceFrom: start to: stop with: replacement startingAt: repStart! !


!Symbol methodsFor: 'accessing' stamp: 'svp 8/12/2002 10:21'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart

	self errorNoModification! !


!Text methodsFor: 'accessing' stamp: 'svp 8/12/2002 10:29'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver starting at index, repStart, in replacementCollection. Do it to both the string and the runs."

	| rep newRepRuns |
	rep _ replacement asText.	"might be a string"
	string replaceFrom: start to: stop with: rep string startingAt: repStart.
	repStart = 1 
		ifTrue: [runs _ runs copyReplaceFrom: start to: stop with: rep runs]
		ifFalse: [newRepRuns _ rep runs copyFrom: repStart to: rep size.
				runs _ runs copyReplaceFrom: start to: stop with: newRepRuns].
! !


!WeakKeyDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 16:49'!
compare: element with: anObject

	^element key = anObject! !

!WeakKeyDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 16:46'!
getHashFor: anObject

	^anObject hash! !

!WeakKeyDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 16:47'!
scanForNil: anObject startingAt: start
	"Private. Scan the key array for the first slot containing nil (indicating an empty slot). Answer the index of that slot."

	"Search from (hash mod size) to the end."
	start to: array size do:
		[:index | (array at: index) == nil ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | (array at: index) == nil ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !


!WeakIdentityKeyDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 09:26'!
compare: element with: object

	^element key == object! !

!WeakIdentityKeyDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 16:51'!
getHashFor: anObject

	^array size > 4096
		ifTrue: [anObject identityHash hashMultiply]
		ifFalse: [anObject identityHash].! !


!WeakSet methodsFor: 'private' stamp: 'svp 8/23/2002 17:32'!
scanFor: anObject startingAt: start
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements"

	| element |

	"Search from (hash mod size) to the end."
	start to: array size do:
		[:index | ((element _ array at: index) == flag or: 
			[self compare: element with: anObject])
				ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element _ array at: index) == flag or: 
			[self compare: element with: anObject])
				ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !


!WordArray methodsFor: 'private' stamp: 'svp 8/12/2002 10:24'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	<primitive: 105>
	^super basicReplaceFrom: start to: stop with: replacement startingAt: repStart ! !

