!B3DActiveEdgeTable methodsFor: 'private' stamp: 'svp 8/12/2002 14:03'!
grow
	| newArray |
	newArray _ array similarSpeciesInstance: array size + 100. "Grow linearly"
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array _ newArray.! !


!B3DPrimitiveEdgeList methodsFor: 'private' stamp: 'svp 8/12/2002 14:11'!
grow
	| newArray |
	newArray _ array similarSpeciesInstance: array size + 100.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array _ newArray.! !


!B3DPrimitiveRasterizerData methodsFor: 'private' stamp: 'svp 8/12/2002 10:08'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	replacement startingAt: repStart replace: self from: start to: stop! !


!B3DPrimitiveRasterizerState methodsFor: 'growing' stamp: 'svp 8/12/2002 14:11'!
grow: anArray
	| newArray |
	newArray _ anArray similarSpeciesInstance: anArray size + (anArray size // 4 max: 100).
	newArray replaceFrom: 1 to: anArray size with: anArray startingAt: 1.
	^newArray! !


!B3DVertexBuffer methodsFor: 'private' stamp: 'svp 8/12/2002 14:11'!
growIndexArray: newSize
	| newIdxArray |
	newIdxArray _ indexArray similarSpeciesInstance: newSize.
	newIdxArray replaceFrom: 1 to: indexArray size with: indexArray startingAt: 1.
	indexArray _ newIdxArray.! !

!B3DVertexBuffer methodsFor: 'private' stamp: 'svp 8/12/2002 14:11'!
growVertexArray: newSize
	| newVtxArray |
	newVtxArray _ vertexArray similarSpeciesInstance: newSize.
	newVtxArray privateReplaceFrom: 1 to: vertexArray basicSize with: vertexArray startingAt: 1.
	vertexArray _ newVtxArray.! !


!BalloonEngine methodsFor: 'copying' stamp: 'svp 8/12/2002 14:11'!
canProceedAfter: failureReason
	"Check if we can proceed after the failureReason indicated."
	| newBuffer |
	failureReason = GErrorNeedFlush ifTrue:[
		"Need to flush engine before proceeding"
		self copyBits.
		self reset.
		^true].
	failureReason = GErrorNoMoreSpace ifTrue:[
		"Work buffer is too small"
		newBuffer _ workBuffer similarSpeciesInstance: workBuffer size * 2.
		self primCopyBufferFrom: workBuffer to: newBuffer.
		workBuffer _ newBuffer.
		^true].
	"Not handled"
	^false! !


!BookMorph methodsFor: 'initialization' stamp: 'svp 8/12/2002 14:12'!
newPages: pageList
	"Replace all my pages with the given list of BookPageMorphs.  After this call, currentPage may be invalid."

	pages _ pages similarSpeciesInstance.
	pages addAll: pageList! !

!BookMorph methodsFor: 'initialization' stamp: 'svp 8/12/2002 14:12'!
newPages: pageList currentIndex: index
	"Replace all my pages with the given list of BookPageMorphs. Make the current page be the page with the given index."

	pages _ pages similarSpeciesInstance.
	pages addAll: pageList.
	pages isEmpty ifTrue: [^ self insertPage].
	self goToPage: index.
! !


!Collection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:12'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection _ self similarSpeciesInstance.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!Collection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:12'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection _ self similarSpeciesInstance.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!Collection methodsFor: 'private' stamp: 'svp 8/12/2002 14:50'!
similarSpeciesInstanceOfSize: size
	"Answer *an instance* of the preferred class for reconstructing the receiver.  
	For example, collections create new collections whenever enumeration messages such as 
	collect: or select: are invoked.  The new kind of collection is determined by 
	the species of the original collection.  Species and class are not always the 
	same.  For example, the species of Interval is Array."

	^self species ofSize: size! !


!CompositeTransform methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:13'!
inverseTransformation
	"Return the inverse transformation of the receiver"
	^self similarSpeciesInstance
		globalTransform: localTransform inverseTransformation
		localTransform: globalTransform inverseTransformation! !


!ExternalSemaphoreTable class methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:14'!
safelyRegisterExternalObject: anObject
	"Register the given object in the external objects array and return its index. If it is already there, just return its index."

	| objects firstEmptyIndex obj sz newObjects |
	objects _ Smalltalk specialObjectsArray at: 39.

	"find the first empty slot"
	firstEmptyIndex _ 0.
	1 to: objects size do: [:i |
		obj _ objects at: i.
		obj == anObject ifTrue: [^ i].  "object already there, just return its index"
		(obj == nil and: [firstEmptyIndex = 0]) ifTrue: [firstEmptyIndex _ i]].

	"if no empty slots, expand the array"
	firstEmptyIndex = 0 ifTrue: [
		sz _ objects size.
		newObjects _ objects similarSpeciesInstance: sz + 20.  "grow linearly"
		newObjects replaceFrom: 1 to: sz with: objects startingAt: 1.
		firstEmptyIndex _ sz + 1.
		Smalltalk specialObjectsArray at: 39 put: newObjects.
		objects _ newObjects].

	objects at: firstEmptyIndex put: anObject.
	^ firstEmptyIndex
! !


!Integer methodsFor: 'system primitives' stamp: 'svp 8/12/2002 10:05'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	replacement startingAt: repStart replace: self from: start to: stop! !

!Integer methodsFor: 'private' stamp: 'svp 8/12/2002 14:15'!
growto: n

	^self copyto: (self similarSpeciesInstance: n)! !


!MIDIFileReader methodsFor: 'track reading' stamp: 'svp 8/12/2002 14:17'!
endAllNotesAt: endTicks
	"End of score; end any notes still sounding."
	"Details: Some MIDI files have missing note-off events, resulting in very long notes. Truncate any such notes encountered."

	| dur |
	activeEvents do: [:e |
		dur _ endTicks - e time.
		dur > maxNoteTicks ifTrue: [dur _ ticksPerQuarter].  "truncate long note"
		e duration: dur].
	activeEvents _ activeEvents similarSpeciesInstance.
! !


!MIDIInputParser methodsFor: 'recording' stamp: 'svp 8/12/2002 14:18'!
clearBuffers
	"Clear the MIDI record buffers. This should be called at the start of recording or real-time MIDI processing."	

	received _ received similarSpeciesInstance: 5000.
	rawDataBuffer _ ByteArray new: 1000.
	sysExBuffer _ WriteStream on: (ByteArray new: 100).
	midiPort ifNotNil: [midiPort ensureOpen; flushInput].
	startTime _ Time millisecondClockValue.
	state _ #idle.
! !


!MatrixTransform2x3 methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:18'!
inverseTransformation
	"Return the inverse transformation of the receiver.
	The inverse transformation is computed by first calculating
	the inverse offset and then computing transformations
	for the two identity vectors (1@0) and (0@1)"
	| r1 r2 r3 m |
	r3 _ self invertPoint: 0@0.
	r1 _ (self invertPoint: 1@0) - r3.
	r2 _ (self invertPoint: 0@1) - r3.
	m _ self similarSpeciesInstance.
	m
		a11: r1 x; a12: r2 x; a13: r3 x;
		a21: r1 y; a22: r2 y; a23: r3 y.
	^m! !


!Path methodsFor: 'transforming' stamp: 'svp 8/12/2002 14:21'!
scaleBy: aPoint 
	"Answers a new Path scaled by aPoint. Does not affect the current data in 
	this Path."

	| newPath | 
	newPath _ self similarSpeciesInstance: self size. 
	newPath form: self form.
	collectionOfPoints do: [:element | newPath add: (element scaleBy: aPoint)].
	^newPath! !

!Path methodsFor: 'transforming' stamp: 'svp 8/12/2002 14:21'!
translateBy: aPoint 
	"Answers a new Path whose elements are translated by aPoint. Does not
	affect the elements of this Path."

	| newPath |
	newPath _ self similarSpeciesInstance: self size.
	newPath form: self form.
	collectionOfPoints do: [:element | newPath add: (element translateBy: aPoint)].
	^newPath! !


!PositionableStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:21'!
next: anInteger 
	"Answer the next anInteger elements of my collection. Must override 
	because default uses self contents species, which might involve a large 
	collection."

	| newArray |
	newArray _ collection similarSpeciesInstance: anInteger.
	1 to: anInteger do: [:index | newArray at: index put: self next].
	^newArray! !

!PositionableStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:21'!
upTo: anObject 
	"Answer a subcollection from the current access position to the 
	occurrence (if any, but not inclusive) of anObject in the receiver. If 
	anObject is not in the collection, answer the entire rest of the receiver."
	| newStream element |
	newStream _ WriteStream on: (collection similarSpeciesInstance: 100).
	[self atEnd or: [(element _ self next) = anObject]]
		whileFalse: [newStream nextPut: element].
	^newStream contents! !

!PositionableStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:21'!
upToEnd
	"Answer a subcollection from the current access position through the last element of the receiver."

	| newStream el |
	newStream _ WriteStream on: (collection similarSpeciesInstance: 100).
	[(el _ self next) == nil] whileFalse: [ newStream nextPut: el ].
	^ newStream contents! !


!InflateStream methodsFor: 'initialize' stamp: 'svp 8/12/2002 14:14'!
on: aCollection from: firstIndex to: lastIndex
	bitBuf _ bitPos _ 0.
	"The decompression buffer has a size of at 64k,
	since we may have distances up to 32k back and
	repetitions of at most 32k length forward"
	collection _ aCollection similarSpeciesInstance: 1 << 16.
	readLimit _ 0. "Not yet initialized"
	position _ 0.
	source _ aCollection.
	sourceLimit _ lastIndex.
	sourcePos _ firstIndex-1.
	state _ StateNewBlock.! !

!InflateStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:14'!
next: anInteger 
	"Answer the next anInteger elements of my collection.  overriden for simplicity"
	| newArray |

	"try to do it the fast way"
	position + anInteger < readLimit ifTrue: [
		newArray _ collection copyFrom: position + 1 to: position + anInteger.
		position _ position + anInteger.
		^newArray
	].

	"oh, well..."
	newArray _ collection similarSpeciesInstance: anInteger.
	1 to: anInteger do: [:index | newArray at: index put: self next].
	^newArray! !

!InflateStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:15'!
upTo: anObject 
	"Answer a subcollection from the current access position to the 
	occurrence (if any, but not inclusive) of anObject in the receiver. If 
	anObject is not in the collection, answer the entire rest of the receiver."
	| newStream element |
	newStream _ WriteStream on: (collection similarSpeciesInstance: 100).
	[self atEnd or: [(element _ self next) = anObject]]
		whileFalse: [newStream nextPut: element].
	^newStream contents! !

!InflateStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:15'!
upToEnd
	"Answer a subcollection from the current access position through the last element of the receiver."

	| newStream buffer |
	buffer _ collection similarSpeciesInstance: 1000.
	newStream _ WriteStream on: (collection similarSpeciesInstance: 100).
	[self atEnd] whileFalse: [newStream nextPutAll: (self nextInto: buffer)].
	^ newStream contents! !

!InflateStream methodsFor: 'huffman trees' stamp: 'svp 8/12/2002 14:14'!
growHuffmanTable: table
	| newTable |
	newTable _ table similarSpeciesInstance: table size * 2.
	newTable replaceFrom: 1 to: table size with: table startingAt: 1.
	^newTable! !


!JPEGReadStream methodsFor: 'huffman trees' stamp: 'svp 8/12/2002 14:15'!
growHuffmanTable: table
	| newTable |
	newTable _ table similarSpeciesInstance: table size * 2.
	newTable replaceFrom: 1 to: table size with: table startingAt: 1.
	^newTable! !


!Presenter methodsFor: 'viewer' stamp: 'svp 8/12/2002 14:22'!
updateViewer: aViewer forceToShow: aCategorySymbol
	"Update the given viewer to make sure it is in step with various possible changes in the outside world, and when reshowing it be sure it shows the given category"

	| aPlayer aPosition newViewer oldOwner wasSticky barHeight cats itsVocabulary aCategory |
	aCategory _ aCategorySymbol ifNotNil: [aViewer currentVocabulary translatedWordingFor: aCategorySymbol].
	cats _ aViewer symbolsOfCategoriesCurrentlyShowing asOrderedCollection.
	itsVocabulary _ aViewer currentVocabulary.
	aCategory ifNotNil: [(cats includes: aCategorySymbol) ifFalse: [cats addFirst: aCategorySymbol]].
	aPlayer _ aViewer scriptedPlayer.
	aPosition _ aViewer position.
	wasSticky _ aViewer isSticky.
	newViewer _ aViewer similarSpeciesInstance visible: false.
	barHeight _ aViewer submorphs first listDirection == #topToBottom
		ifTrue:
			[aViewer submorphs first submorphs first height]
		ifFalse:
			[0].
	Preferences viewersInFlaps ifTrue:
		[newViewer setProperty: #noInteriorThumbnail toValue: true].

	newViewer rawVocabulary: itsVocabulary.
	newViewer limitClass: aViewer limitClass.
	newViewer initializeFor: aPlayer barHeight: barHeight includeDismissButton: aViewer hasDismissButton showCategories: cats.
	wasSticky ifTrue: [newViewer beSticky].
	oldOwner _ aViewer owner.
	oldOwner ifNotNil:
		[oldOwner replaceSubmorph: aViewer by: newViewer].
	
	"It has happened that old readouts are still on steplist.  We may see again!!"

	newViewer position: aPosition.
	newViewer enforceTileColorPolicy.
	newViewer visible: true.
	newViewer world doIfNotNil: [:aWorld | aWorld startSteppingSubmorphsOf: newViewer].
	newViewer layoutChanged! !


!ScorePlayer methodsFor: 'midi output' stamp: 'svp 8/12/2002 14:22'!
stopMIDIPlaying
	"Terminate the MIDI player process and turn off any active notes."

	midiPlayerProcess ifNotNil: [midiPlayerProcess terminate].
	midiPlayerProcess _ nil.
	activeMIDINotes do: [:pair | pair first endNoteOnMidiPort: midiPort].
	activeMIDINotes _ activeMIDINotes similarSpeciesInstance.
! !

!ScorePlayer methodsFor: 'operating' stamp: 'svp 8/12/2002 14:22'!
pause
	"Pause this sound. It can be resumed from this point, or reset and resumed to start from the beginning."

	score pauseFrom: self.
	super pause.
	activeSounds _ activeSounds similarSpeciesInstance.
	midiPort ifNotNil: [self stopMIDIPlaying].
! !


!SequenceableCollection methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:50'!
atAll: indexArray
	"Answer a new collection like the receiver which contains all elements
	of the receiver at the indices of indexArray."
	"#('one' 'two' 'three' 'four') atAll: #(3 2 4)"

	| newCollection |
	newCollection _ self similarSpeciesInstanceOfSize: indexArray size.
	1 to: indexArray size do:
		[:index |
		newCollection at: index put: (self at: (indexArray at: index))].
	^ newCollection! !

!SequenceableCollection methodsFor: 'converting' stamp: 'svp 8/12/2002 14:51'!
reversed
	"Answer a copy of the receiver with element order reversed."
	"Example: 'frog' reversed"

	| n result src |
	n _ self size.
	result _ self similarSpeciesInstance: n.
	src _ n + 1.
	1 to: n do: [:i | result at: i put: (self at: (src _ src - 1))].
	^ result
! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:51'!
copyEmpty
	^ self similarSpeciesInstance: 0! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 13:54'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize _ stop - start + 1.
	^(self similarSpeciesInstance: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 13:54'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver satisfying the following conditions: If 
	stop is less than start, then this is an insertion; stop should be exactly 
	start-1, start = 1 means insert before the first character, start = size+1 
	means append after last character. Otherwise, this is a replacement; start 
	and stop have to be within the receiver's bounds."

	| newSequenceableCollection newSize endReplacement |
	newSize _ self size - (stop - start + 1) + replacementCollection size.
	endReplacement _ start - 1 + replacementCollection size.
	newSequenceableCollection _ self similarSpeciesInstance: newSize.
	start > 1 ifTrue:[
		newSequenceableCollection
			replaceFrom: 1
			to: start - 1
			with: self
			startingAt: 1].
	start <= endReplacement ifTrue:[
		newSequenceableCollection
			replaceFrom: start
			to: endReplacement
			with: replacementCollection
			startingAt: 1].
	endReplacement < newSize ifTrue:[
		newSequenceableCollection
			replaceFrom: endReplacement + 1
			to: newSize
			with: self
			startingAt: stop + 1].
	^newSequenceableCollection! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:51'!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and has 
	newElement at the last element."

	| newIC |
	newIC _ self similarSpeciesInstance: self size + 1.
	newIC 
		replaceFrom: 1
		to: self size
		with: self
		startingAt: 1.
	newIC at: newIC size put: newElement.
	^newIC! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:51'!
copyWithoutIndex: index
	"Return a copy containing all elements except the index-th."

	| copy |
	copy := self similarSpeciesInstanceOfSize: self size - 1.
	copy replaceFrom: 1 to: index-1 with: self startingAt: 1.
	copy replaceFrom: index to: copy size with: self startingAt: index+1.
	^ copy! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:51'!
forceTo: length paddingStartWith: elem 
	"Force the length of the collection to length, padding  
	the beginning of the result if necessary with elem.  
	Note that this makes a copy."
	| newCollection padLen |
	newCollection _ self similarSpeciesInstance: length.
	padLen _ length - self size max: 0.
	newCollection
		from: 1
		to: padLen
		put: elem.
	newCollection
		replaceFrom: padLen + 1
		to: ((padLen + self size) min: length)
		with: self
		startingAt:  1.
	^ newCollection! !

!SequenceableCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:51'!
forceTo: length paddingWith: elem
	"Force the length of the collection to length, padding
	if necessary with elem.  Note that this makes a copy."

	| newCollection copyLen |
	newCollection _ self similarSpeciesInstance: length.
	copyLen _ self size min: length.
	newCollection replaceFrom: 1 to: copyLen with: self startingAt: 1.
	newCollection from: copyLen + 1 to: length put: elem.
	^ newCollection! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:50'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection _ self similarSpeciesInstance: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:51'!
collect: aBlock from: firstIndex to: lastIndex
	"Refer to the comment in Collection|collect:."

	| size result j |
	size _ lastIndex - firstIndex + 1.
	result _ self similarSpeciesInstance: size.
	j _ firstIndex.
	1 to: size do: [:i | result at: i put: (aBlock value: (self at: j)). j _ j + 1].
	^ result! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:51'!
select: aBlock 
	"Refer to the comment in Collection|select:."
	| aStream |
	aStream _ WriteStream on: (self similarSpeciesInstance: self size).
	1 to: self size do: 
		[:index |
		(aBlock value: (self at: index))
			ifTrue: [aStream nextPut: (self at: index)]].
	^ aStream contents! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:52'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result _ self similarSpeciesInstance: self size.
	1 to: self size do:
		[:index | result at: index put:
		(twoArgBlock
			value: (self at: index)
			value: (otherCollection at: index))].
	^ result! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:52'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block."
	| result |
	result _ self similarSpeciesInstance: self size.
	1 to: self size do:
		[:index | result at: index put:
		(elementAndIndexBlock
			value: (self at: index)
			value: index)].
	^ result! !

!SequenceableCollection methodsFor: 'replacement' stamp: 'svp 8/12/2002 09:55'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	replacement startingAt: repStart replace: self from: start to: stop! !


!DependentsArray methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:13'!
select: aBlock 
	"Refer to the comment in Collection|select:."
	| aStream |
	aStream _ WriteStream on: (self similarSpeciesInstance: self size).
	self do:[:obj|
		(aBlock value: obj)
			ifTrue: [aStream nextPut: obj]].
	^ aStream contents! !


!B3DInplaceArray methodsFor: 'copying' stamp: 'svp 8/12/2002 14:10'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize _ stop - start + 1.
	^(self similarSpeciesInstance: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !


!Interval methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:15'!
collect: aBlock
	| nextValue result |
	result _ self similarSpeciesInstance: self size.
	nextValue _ start.
	1 to: result size do:
		[:i |
		result at: i put: (aBlock value: nextValue).
		nextValue _ nextValue + step].
	^ result! !


!MappedCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:18'!
collect: aBlock 
	"Refer to the comment in Collection|collect:."

	| aStream |
	aStream _ WriteStream on: (self similarSpeciesInstance: self size).
	self do:
		[:domainValue | 
		aStream nextPut: (aBlock value: domainValue)].
	^aStream contents! !

!MappedCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:18'!
select: aBlock 
	"Refer to the comment in Collection|select:."

	| aStream |
	aStream _ WriteStream on: (self similarSpeciesInstance: self size).
	self do:
		[:domainValue | 
		(aBlock value: domainValue)
			ifTrue: [aStream nextPut: domainValue]].
	^aStream contents! !


!OrderedCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:20'!
copyEmpty
	"Answer a copy of the receiver that contains no elements."

	^self similarSpeciesInstance! !

!OrderedCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:20'!
copyFrom: startIndex to: endIndex 
	"Answer a copy of the receiver that contains elements from position
	startIndex to endIndex."

	| targetCollection |
	endIndex < startIndex ifTrue: [^self similarSpeciesInstance: 0].
	targetCollection _ self similarSpeciesInstance: endIndex + 1 - startIndex.
	startIndex to: endIndex do: [:index | targetCollection addLast: (self at: index)].
	^ targetCollection! !

!OrderedCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:20'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver with replacementCollection's elements in
	place of the receiver's start'th to stop'th elements. This does not expect
	a 1-1 map from replacementCollection to the start to stop elements, so it
	will do an insert or append."

	| newOrderedCollection delta startIndex stopIndex |
	"if start is less than 1, ignore stop and assume this is inserting at the front. 
	if start greater than self size, ignore stop and assume this is appending. 
	otherwise, it is replacing part of me and start and stop have to be within my 
	bounds. "
	delta _ 0.
	startIndex _ start.
	stopIndex _ stop.
	start < 1
		ifTrue: [startIndex _ stopIndex _ 0]
		ifFalse: [startIndex > self size
				ifTrue: [startIndex _ stopIndex _ self size + 1]
				ifFalse: 
					[(stopIndex < (startIndex - 1) or: [stopIndex > self size])
						ifTrue: [self errorOutOfBounds].
					delta _ stopIndex - startIndex + 1]].
	newOrderedCollection _ 
		self similarSpeciesInstance: self size + replacementCollection size - delta.
	1 to: startIndex - 1 do: [:index | newOrderedCollection add: (self at: index)].
	1 to: replacementCollection size do: 
		[:index | newOrderedCollection add: (replacementCollection at: index)].
	stopIndex + 1 to: self size do: [:index | newOrderedCollection add: (self at: index)].
	^newOrderedCollection! !

!OrderedCollection methodsFor: 'copying' stamp: 'svp 8/12/2002 14:20'!
reversed
	"Answer a copy of the receiver with element order reversed.  "
	| newCol |
	newCol _ self similarSpeciesInstance.
	self reverseDo:
		[:elem | newCol addLast: elem].
	^ newCol

"#(2 3 4 'fred') reversed"! !

!OrderedCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:19'!
collect: aBlock from: fromIndex to: toIndex
	"Override superclass in order to use addLast:, not at:put:."
	| result |
	(fromIndex < 1 or:[toIndex + firstIndex - 1 > lastIndex])
		ifTrue: [^self errorNoSuchElement].
	result _ self similarSpeciesInstance: toIndex - fromIndex + 1.
	firstIndex + fromIndex - 1 to: firstIndex + toIndex - 1 do:
		[:index | result addLast: (aBlock value: (array at: index))].
	^ result
! !

!OrderedCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:20'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with 
	corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result _ self similarSpeciesInstance: self size.
	1 to: self size do:
		[:index | result addLast: (twoArgBlock value: (self at: index)
									value: (otherCollection at: index))].
	^ result! !

!OrderedCollection methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:20'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection _ self similarSpeciesInstance: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (elementAndIndexBlock
			value: (array at: index)
			value: index - firstIndex + 1)].
	^ newCollection! !


!Set methodsFor: 'private' stamp: 'svp 8/12/2002 13:54'!
rehash
	| newSelf |
	newSelf _ self similarSpeciesInstance: self size.
	self do: [:each | newSelf noCheckAdd: each].
	array _ newSelf array! !

!Set methodsFor: 'private' stamp: 'svp 8/23/2002 09:48'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	^self 
		scanFor: anObject 
		hash: (self getHashFor: anObject)
! !


!Dictionary methodsFor: 'enumerating' stamp: 'svp 8/12/2002 14:13'!
select: aBlock 
	"Evaluate aBlock with each of my values as the argument. Collect into a
	new dictionary, only those associations for which aBlock evaluates to
	true."

	| newCollection |
	newCollection _ self similarSpeciesInstance.
	self associationsDo: 
		[:each | 
		(aBlock value: each value) ifTrue: [newCollection add: each]].
	^newCollection! !

!Dictionary methodsFor: 'private' stamp: 'svp 8/12/2002 14:13'!
rehash
	"Smalltalk rehash."
	| newSelf |
	newSelf _ self similarSpeciesInstance: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array _ newSelf array! !


!IdentityDictionary methodsFor: 'image conversion' stamp: 'svp 8/23/2002 16:26'!
cloneUsingHashesFrom: tracer

	| object newDict |
	newDict := self shallowCopy.
	newDict withArray: (Array new: array size).
	1 to: array size do:
		[ :i |
		object := array at: i.
		object ifNotNil:
			[newDict
				noCheckAdd: object
				hash: (tracer identityHashFor: object key)]].
	^newDict! !

!IdentityDictionary methodsFor: 'image conversion' stamp: 'svp 8/23/2002 18:36'!
noCheckAdd: anObject hash: hash
	"Variant to allow the hash to be specified
	by the caller.  8/23/02 svp"

	array at: (self findElementOrNil: anObject key hash: hash) put: anObject.
	tally _ tally + 1! !


!MethodDictionary methodsFor: 'private' stamp: 'svp 8/12/2002 14:18'!
grow 
	| newSelf key |
	newSelf _ self similarSpeciesInstance: self basicSize.  "This will double the size"
	1 to: self basicSize do:
		[:i | key _ self basicAt: i.
		key == nil ifFalse: [newSelf at: key put: (array at: i)]].
	self become: newSelf! !

!MethodDictionary methodsFor: 'private' stamp: 'svp 8/12/2002 14:19'!
growNoBecome
 
	| newSelf key |

	newSelf _ self similarSpeciesInstance: self basicSize.  "This will double the size"
	1 to: self basicSize do:
		[:i | key _ self basicAt: i.
		key == nil ifFalse: [newSelf at: key put: (array at: i)]].
	^newSelf! !

!MethodDictionary methodsFor: 'private' stamp: 'svp 8/12/2002 14:19'!
rehash 
	| newSelf key |
	newSelf _ self similarSpeciesInstance: self size.
	1 to: self basicSize do:
		[:i | key _ self basicAt: i.
		key == nil ifFalse: [newSelf at: key put: (array at: i)]].
	self become: newSelf! !

!MethodDictionary methodsFor: 'private' stamp: 'svp 8/12/2002 14:19'!
rehashWithoutBecome
	| newSelf key |
	newSelf _ self similarSpeciesInstance: self size.
	1 to: self basicSize do:
		[:i | key _ self basicAt: i.
		key == nil ifFalse: [newSelf at: key put: (array at: i)]].
	^newSelf! !

!MethodDictionary methodsFor: 'image conversion' stamp: 'svp 8/23/2002 16:27'!
cloneUsingHashesFrom: tracer

	| newDict key |
	newDict := self class basicNew: self basicSize.
	newDict init: array size.
	1 to: self basicSize do: 
		[ :i |
		key := self basicAt: i.
		key ifNotNil: 
			[newDict 
				noCheckAt: key 
				put: (array at: i) 
				hash: (tracer identityHashFor: key)]].
	^newDict! !

!MethodDictionary methodsFor: 'image conversion' stamp: 'svp 8/23/2002 16:26'!
noCheckAt: key put: value hash: identityHash
	"Set the value at key to be value."
	| index |
	index _ self findElementOrNil: key hash: identityHash.
	(self basicAt: index) == nil
		ifTrue: 
			[tally _ tally + 1.
			self basicAt: index put: key].
	array at: index put: value.
	^ value! !


!SourceFileArray methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:52'!
collect: aBlock
	| copy |
	copy _ self similarSpeciesInstance: self size.
	1 to: self size do:[:i| copy at: i put: (aBlock value: (self at: i))].
	^copy! !


!SystemDictionary methodsFor: 'miscellaneous' stamp: 'svp 8/23/2002 00:11'!
rehashEntireImage
	"Note, we cannot use allObjectsDo: because some objects like to swap identities
	during a rehash...this means that allObjectsDo: will not find all objects.  Also, this
	algorithm delays become operations to the very end where we can do them all at once. -svp"

	| objectCount allObjects numMdicts oldObjs newObjs newObject |

	numMdicts := MethodDictionary allInstances size.
	oldObjs := OrderedCollection new: numMdicts.
	newObjs := OrderedCollection new: numMdicts.

	"Create an array big enough to hold all objects in memory"
	objectCount := 0.
	self allObjectsDo: [ :ea | objectCount := objectCount + 1].
	allObjects := Array new: objectCount + 500.

	"Now fill the array"
	objectCount := 0.
	self allObjectsDo: [ :ea | allObjects at: (objectCount := objectCount + 1) put: ea ].

	'Rehashing the image: ', objectCount printString, ' objects' 
		displayProgressAt: Display center
		from: 1 to: objectCount
		during: [:bar | 
			objectCount := 0.
			allObjects do: [ :ea |
				bar value: (objectCount := objectCount + 1).
				newObject := ea rehashWithoutBecome.
				(newObject ~~ ea) ifTrue: 
					[oldObjs add: ea.
					newObjs add: newObject].
			].
			oldObjs asArray elementsExchangeIdentityWith: newObjs asArray.
		].! !


!TMethod methodsFor: 'inlining support' stamp: 'svp 8/12/2002 14:52'!
renameVariablesUsing: aDictionary
	"Rename all variables according to old->new mappings of the given dictionary."

	| newDecls |
	"map args and locals"
	args _ args collect: [ :arg |
		(aDictionary includesKey: arg) ifTrue: [ aDictionary at: arg ] ifFalse: [ arg ].
	].
	locals _ locals collect: [ :v |
		(aDictionary includesKey: v) ifTrue: [ aDictionary at: v ] ifFalse: [ v ].
	].

	"map declarations"
	newDecls _ declarations similarSpeciesInstance.
	declarations associationsDo: [ :assoc |
		(aDictionary includesKey: assoc key)
			ifTrue: [ newDecls at: (aDictionary at: assoc key) put: assoc value ]
			ifFalse: [ newDecls add: assoc ].
	].
	declarations _ newDecls.

	"map variable names in parse tree"
	parseTree nodesDo: [ :node |
		(node isVariable and:
		 [aDictionary includesKey: node name]) ifTrue: [
			node setName: (aDictionary at: node name).
		].
		(node isStmtList and: [node args size > 0]) ifTrue: [
			node setArguments:
				(node args collect: [ :arg |
					(aDictionary includesKey: arg)
						ifTrue: [ aDictionary at: arg ]
						ifFalse: [ arg ].
				]).
		].
	].! !


!TabbedPalette methodsFor: 'initialization' stamp: 'svp 8/12/2002 14:53'!
newTabs: tabsList
	"Reconstitute the palette based on info in the tabs list"

	| itsBook color1 color2 color3 |
	pages _ pages similarSpeciesInstance.
	tabsMorph ifNotNil:
		[color1 _ tabsMorph  highlightColor.
		color2 _ tabsMorph regularColor.
		color3 _ tabsMorph color.
		tabsMorph delete].
	tabsMorph _ IndexTabs new.
	self addMorphFront: tabsMorph.
	color1 ifNotNil:
		[tabsMorph highlightColor: color1 regularColor: color2; color: color3].
	currentPage ifNotNil:
		[currentPage delete.
		currentPage _ nil].
	tabsList do:
		[:aTab |
			tabsMorph addTab: aTab.
			aTab unHighlight.
			(itsBook _ aTab morphToInstall) ifNotNil:
					[pages add: itsBook.
					currentPage ifNil: [currentPage _ itsBook]]].
	tabsMorph position: self position + self borderWidth! !


!WaveEditor methodsFor: 'other' stamp: 'svp 8/12/2002 14:53'!
normalize: sampleArray
	"Return a copy of the given sample array scaled to use the maximum 16-bit sample range. Remove any D.C. offset."

	| max abs scale out |
	max _ 0.
	sampleArray do: [:s |
		s > 0 ifTrue: [abs _ s] ifFalse: [abs _ 0 - s].
		abs > max ifTrue: [max _ abs]].
	scale _ ((1 << 15) - 1) asFloat / max.

	out _ sampleArray similarSpeciesInstance: sampleArray size.
	1 to: sampleArray size do: [:i |
		out at: i put: (scale * (sampleArray at: i)) truncated].
	^ out
! !


!WeakKeyDictionary methodsFor: 'private' stamp: 'svp 8/23/2002 16:49'!
scanForNil: anObject
	"Private. Scan the key array for the first slot containing nil (indicating an empty slot). Answer the index of that slot."

	^self 
		scanForNil: anObject
		startingAt: ((self getHashFor: anObject) \\ array size) + 1.
! !


!WeakSet methodsFor: 'public' stamp: 'svp 8/12/2002 14:53'!
collect: aBlock
	| each newSet |
	newSet _ self similarSpeciesInstance: self size.
	tally = 0 ifTrue: [^newSet ].
	1 to: array size do:
		[:index |
			((each _ array at: index) == nil or: [each == flag])
				ifFalse: [newSet add: (aBlock value: each)]
		].
	^newSet! !

!WeakSet methodsFor: 'image conversion' stamp: 'svp 8/23/2002 16:26'!
cloneUsingHashesFrom: tracer

	| newSet object |
	newSet := self class basicNew init: array size.
	1 to: array size do:
		[ :i |
		object := array at: i.
		(object == flag or: [object == nil]) ifFalse:
			[newSet 
				noCheckAdd: object
				hash: (object hashMappedBy: tracer)]].
	^newSet! !

!WeakSet methodsFor: 'image conversion' stamp: 'svp 8/23/2002 16:27'!
noCheckAdd: anObject hash: hash
	array at: (self findElementOrNil: anObject hash: hash) put: anObject.
	tally _ tally + 1! !


!WriteStream methodsFor: 'private' stamp: 'svp 8/12/2002 14:02'!
pastEndPut: anObject
	"Grow the collection by creating a new bigger collection and then
	copy over the contents from the old one. We grow by doubling the size
	but the growth is kept between 20 and 1000000.
	Finally we put <anObject> at the current write position."

	| oldSize grownCollection |
	oldSize _ collection size.
	grownCollection _ collection similarInstance: oldSize + ((oldSize max: 20) min: 1000000).
	collection _ grownCollection replaceFrom: 1 to: oldSize with: collection startingAt: 1.
	writeLimit _ collection size.
	collection at: (position _ position + 1) put: anObject! !


!DeflateStream methodsFor: 'initialize-release' stamp: 'svp 8/12/2002 14:13'!
on: aCollection
	self initialize.
	super on: (aCollection similarSpeciesInstance: WindowSize * 2).! !


!FileStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:14'!
next: anInteger

	| newCollection howManyRead increment |
	newCollection _ collection similarSpeciesInstance: anInteger.
	howManyRead _ 0.
	[howManyRead < anInteger] whileTrue:
		[self atEnd ifTrue:
			[(howManyRead + 1) to: anInteger do: [:i | newCollection at: i put: (self next)].
			^newCollection].
		increment _ (readLimit - position) min: (anInteger - howManyRead).
		newCollection replaceFrom: (howManyRead + 1)
			to: (howManyRead _ howManyRead + increment)
			with: collection
			startingAt: (position + 1).
		position _ position + increment].
	^newCollection! !


!StandardFileStream methodsFor: 'read, write, position' stamp: 'svp 8/12/2002 14:52'!
upToEnd
	"Answer a subcollection from the current access position through the last element of the receiver."

	| newStream buffer |
	buffer _ buffer1 similarSpeciesInstance: 1000.
	newStream _ WriteStream on: (buffer1 species new: 100).
	[self atEnd] whileFalse: [newStream nextPutAll: (self nextInto: buffer)].
	^ newStream contents! !

WordArray removeSelector: #replaceFrom:to:with:startingAt:!
Text removeSelector: #replaceFrom:to:with:startingAt:!
Symbol removeSelector: #replaceFrom:to:with:startingAt:!
B3DInplaceArray removeSelector: #replaceFrom:to:with:startingAt:!
FloatArray removeSelector: #replaceFrom:to:with:startingAt:!
ByteArray removeSelector: #replaceFrom:to:with:startingAt:!
Bitmap removeSelector: #replaceFrom:to:with:startingAt:!
Array removeSelector: #replaceFrom:to:with:startingAt:!
LargePositiveInteger removeSelector: #replaceFrom:to:with:startingAt:!
B3DIndexedTriangle removeSelector: #replaceFrom:to:with:startingAt:!
B3DIndexedQuad removeSelector: #replaceFrom:to:with:startingAt:!
"Postscript:
We need to rehash any existing large identity based sets because the hash has been changed to a slightly more efficient one.  Also, we need to remove the old #scanFor: methods in a delicate order."

Set allSubInstances do:
	[ :ea | ea array size > 4096 ifTrue: [ea rehash]].

Dictionary removeSelector: #scanFor:.
IdentityDictionary removeSelector: #scanFor:.
IdentitySet removeSelector: #scanFor:.
WeakSet removeSelector: #scanFor:.
WeakKeyDictionary removeSelector: #scanFor:.
WeakIdentityKeyDictionary removeSelector: #scanFor:.
WeakIdentityKeyDictionary removeSelector: #scanForNil:.
PluggableSet removeSelector: #scanFor:.
PluggableDictionary removeSelector: #scanFor:.
LiteralDictionary removeSelector: #scanFor:.
MethodDictionary removeSelector: #scanFor:.!

!WeakSet methodsFor: 'public' stamp: 'svp 8/12/2002 14:53'!
collect: aBlock
	| each newSet |
	newSet _ self similarSpeciesInstance: self size.
	tally = 0 ifTrue: [^newSet ].
	1 to: array size do:
		[:index |
			((each _ array at: index) == nil or: [each == flag])
				ifFalse: [newSet add: (aBlock value: each)]
		].
	^newSet! !


!WordArray methodsFor: 'private' stamp: 'svp 8/12/2002 10:24'!
basicReplaceFrom: start to: stop with: replacement startingAt: repStart 
	<primitive: 105>
	^super basicReplaceFrom: start to: stop with: replacement startingAt: repStart ! !


!WriteStream methodsFor: 'private' stamp: 'svp 8/12/2002 14:02'!
pastEndPut: anObject
	"Grow the collection by creating a new bigger collection and then
	copy over the contents from the old one. We grow by doubling the size
	but the growth is kept between 20 and 1000000.
	Finally we put <anObject> at the current write position."

	| oldSize grownCollection |
	oldSize _ collection size.
	grownCollection _ collection similarInstance: oldSize + ((oldSize max: 20) min: 1000000).
	collection _ grownCollection replaceFrom: 1 to: oldSize with: collection startingAt: 1.
	writeLimit _ collection size.
	collection at: (position _ position + 1) put: anObject! !


!DeflateStream methodsFor: 'initialize-release' stamp: 'svp 8/12/2002 14:13'!
on: aCollection
	self initialize.
	super on: (aCollection similarSpeciesInstance: WindowSize * 2).! !


!FileStream methodsFor: 'accessing' stamp: 'svp 8/12/2002 14:14'!
next: anInteger

	| newCollection howManyRead increment |
	newCollection _ collection similarSpeciesInstance: anInteger.
	howManyRead _ 0.
	[howManyRead < anInteger] whileTrue:
		[self atEnd ifTrue:
			[(howManyRead + 1) to: anInteger do: [:i | newCollection at: i put: (self next)].
			^newCollection].
		increment _ (readLimit - position) min: (anInteger - howManyRead).
		newCollection replaceFrom: (howManyRead + 1)
			to: (howManyRead _ howManyRead + increment)
			with: collection
			startingAt: (position + 1).
		position _ position + increment].
	^newCollection! !


!StandardFileStream methodsFor: 'read, write, position' stamp: 'svp 8/12/2002 14:52'!
upToEnd
	"Answer a subcollection from the current access position through the last element of the receiver."

	| newStream buffer |
	buffer _ buffer1 similarSpeciesInstance: 1000.
	newStream _ WriteStream on: (buffer1 species new: 100).
	[self atEnd] whileFalse: [newStream nextPutAll: (self nextInto: buffer)].
	^ newStream contents! !

WordArray removeSelector: #replaceFrom:to:with:startingAt:!
Text removeSelector: #replaceFrom:to:with:startingAt:!
Symbol removeSelector: #replaceFrom:to:with:startingAt:!
String removeSelector: #replaceFrom:to:with:startingAt:!
B3DInplaceArray removeSelector: #replaceFrom:to:with:startingAt:!
FloatArray removeSelector: #replaceFrom:to:with:startingAt:!
ByteArray removeSelector: #replaceFrom:to:with:startingAt:!
Bitmap removeSelector: #replaceFrom:to:with:startingAt:!
Array removeSelector: #replaceFrom:to:with:startingAt:!
LargePositiveInteger removeSelector: #replaceFrom:to:with:startingAt:!
B3DIndexedTriangle removeSelector: #replaceFrom:to:with:startingAt:!
B3DIndexedQuad removeSelector: #replaceFrom:to:with:startingAt:!
Object removeSelector: #speciesNew!
Object removeSelector: #speciesNew:!
"Postscript:
We need to rehash any existing large identity based sets because the hash has been changed to a slightly more efficient one."

WeakIdentityKeyDictionary allInstances 
	do: [ :ea | ea array size > 4096 ifTrue: [ea rehash]].

IdentitySet allInstances 
	do: [ :ea | ea array size > 4096 ifTrue: [ea rehash]].

IdentityDictionary allInstances 
	do: [ :ea | ea array size > 4096 ifTrue: [ea rehash]].!
